//: C05:PocitanaTrida2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// chybný pokus o počítání objektů.
#include <iostream>
using namespace std;

class Pocitana {
  static int pocet;
public:
  Pocitana() { ++pocet; }
  Pocitana(const Pocitana&) { ++pocet; }
  ~Pocitana() { --pocet; }
  static int zjistiPocet() { return pocet; }
};

int Pocitana::pocet = 0;

class PocitanaTrida : public Pocitana {};
class PocitanaTrida2 : public Pocitana {};

int main() {
  PocitanaTrida a;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 1
  PocitanaTrida b;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 2
  PocitanaTrida2 c;
  cout << PocitanaTrida2::zjistiPocet() << endl;   // 3 (Error)
} ///:~
